const webpack = require('webpack')
const path = require('path')
const appConfig = require('../utils/get-app-config')
const { resolve } = require('../utils')

const config = {
  cache: true,
  mode: 'none',
  entry: resolve('client/entry-client.js'),
  output: {
    path: path.resolve(__dirname, './dist'),
    publicPath: '/dist/',
    filename: 'build.js'
  },
  devtool: '#eval-source-map',
  module: {
    rules: [
      {
        test: /\.js$/,
        loader: 'babel-loader',
        include: [resolve('client'), resolve('test')],
      },
      {
        test: /\.vue$/,
        loader: 'vue-loader',
      },
    ]
  },
  resolve: {
    alias: {
      'vue$': 'vue/dist/vue.esm.js'
    },
    extensions: ['.js']
  },
  performance: {
    hints: false
  },
  plugins: [
    new webpack.DefinePlugin({
      'process.env': {
        NODE_ENV: '"test"',
        BABEL_ENV: '"test"',
      },
    }),
  ],
}

// module.exports = config
module.exports = function testWebpack(isTDD) {
  if (isTDD) {
    config.devServer = {
      historyApiFallback: true,
      noInfo: true,
      overlay: true,
    }
  }

  return config
}
